from concatenation import (
    __version__,
    naive_concatenate,
    new_list_concatenate,
    in_place_concatenate,
)
import pytest


def test_version():
    assert __version__ == "0.1.0"


@pytest.fixture
def concat_data():
    destination_list = list(range(10000))
    source_list = list(range(1000, 8000))
    result = list(range(1500, 8000)) + list(range(6500, 10000))
    return destination_list, source_list, result


def test_naive_concatenate(concat_data, benchmark):
    assert benchmark(naive_concatenate, *concat_data[:2], 0, 500) == concat_data[-1]


def test_new_list_concatenate(concat_data, benchmark):
    assert concat_data[0] != concat_data[-1]
    assert benchmark(new_list_concatenate, *concat_data[:2], 0, 500) == concat_data[-1]


def test_in_place_concatenate(concat_data, benchmark):
    assert concat_data[0] != concat_data[-1]
    assert benchmark(in_place_concatenate, *concat_data[:2], 0, 500) == concat_data[-1]
